;/////////////////////////////////////////////////////////
;// Rough demo of using the GlobalMemoryStatus API.///////
;// Petezl 28-12-04 //////////////////////////////////////
;/////////////////////////////////////////////////////////

.386
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc      ; // included for the dwtoa function
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib       ; // included for the dwtoa function

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
hInstance dd 0
buff db 16 dup(?)       ; // General use buffer
; 

.code
start:

invoke GetModuleHandle, NULL
mov hInstance, eax
invoke DialogBoxParam,hInstance,700,0,ADDR DlgProc,0
invoke ExitProcess,eax
; 

DlgProc proc uses esi edi hDlg:DWORD,uMsg:DWORD, wParam:DWORD,lParam:DWORD
;  // esi & edi(above)used in dwtoa function

LOCAL mst:MEMORYSTATUS    ;  // Declare memory structure-The type def is shown below

;typedef struct _MEMORYSTATUS { // mst
; DWORD dwLength;        // sizeof(MEMORYSTATUS)
; DWORD dwMemoryLoad;    // percent of memory in use
; DWORD dwTotalPhys;     // bytes of physical memory
; DWORD dwAvailPhys;     // free physical memory bytes
; DWORD dwTotalPageFile; // bytes of paging file
; DWORD dwAvailPageFile; // free bytes of paging file
; DWORD dwTotalVirtual;  // user bytes of address space
; DWORD dwAvailVirtual;  // free user bytes
;} MEMORYSTATUS, *LPMEMORYSTATUS;


.if uMsg == WM_CLOSE
invoke EndDialog,hDlg,0

.elseif uMsg == WM_INITDIALOG
invoke GlobalMemoryStatus,ADDR mst          ;//load the structure with current data.

invoke dwtoa, mst.dwLength, addr buff       ;// convert dw to ascii and place in buffer.
invoke SetDlgItemText, hDlg, 3001,ADDR buff ;// place respective data into editboxes.

invoke dwtoa, mst.dwMemoryLoad, addr buff
invoke SetDlgItemText, hDlg, 3002,ADDR buff

invoke dwtoa, mst.dwTotalPhys, addr buff
invoke SetDlgItemText, hDlg, 3003,ADDR buff

invoke dwtoa, mst.dwAvailPhys, addr buff
invoke SetDlgItemText, hDlg, 3004,ADDR buff

invoke dwtoa, mst.dwTotalPageFile, addr buff
invoke SetDlgItemText, hDlg, 3005,ADDR buff

invoke dwtoa, mst.dwAvailPageFile, addr buff
invoke SetDlgItemText, hDlg, 3006,ADDR buff

invoke dwtoa, mst.dwTotalVirtual, addr buff
invoke SetDlgItemText, hDlg, 3007,ADDR buff

invoke dwtoa, mst.dwAvailVirtual, addr buff
invoke SetDlgItemText, hDlg, 3008,ADDR buff

.else
xor eax,eax
ret
.endif
ret
DlgProc endp
; 

end start